// Face Viewer class.
// Taken from Axis Viewer
// Extends Panel class.
//
// This class is the interface between the application
// and the D3 cube class.  It handles the buttons for
// face rotation requests.  Adapted from AxisViewer -- 
// hopefully now defunct.
//
// Idea:  Click on a particular cubie and see that cubie
// highlighted in all the other cubes where it's visible.
// This functionality needs to be added to the C4 Cube.
// 

import java.awt.*;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Event;
import java.awt.event.*;
import java.util.Vector;
import java.io.*;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import java.util.EventListener;
import java.lang.Math;

class FaceViewer extends Panel implements ActionListener  
		, Runnable
//		, MouseMotionListener 
//		, MouseListener 
//		 , ItemListener 
	{
	
	protected static int smallSleep = 5;
	protected static int bigSleep = 100;
		
	// double buffering:
    protected Image OffScrImg;
    protected Graphics OffScrG;

	public boolean DEBUG = true;
	
//	int VRotFace=0;
	
	// 3d faces for this axis 
	protected VCube D3Face;
	protected C4VCube parent;  // the parent of this viewer.  
	protected int myAxis; // Fixed axis in C4 cube
	protected int myFace; // Face number of this face
	protected int cx, cy;
	protected int hsize, vsize;
	protected int divX, divY;   // converting location of mouse dragging to degrees of rotation

	protected Thread myThread;
	
//	protected boolean isRotating;  // for the face rotater, mouse clicking
	
//	protected faceRotater fR;

	protected int clickX, clickY; // For mouse down, rotating visually
	protected boolean mouseIsDown;
	
//	protected int oldX, oldY;  // for mouse drags
   	protected Button RotateFaceButtons[];
//    Choice WhichFace;  // for visual rotation
//    String Message1, Message2;
    protected int dTheta = 5;
//    Button RotateVButtons[];

	public FaceViewer(int FNum, int h, int v, C4VCube p) {
		myFace = FNum;  // The face 0 to 7
		myAxis = FNum%4;  // axis this face is on
		parent = p;  // the parent of this viewer
		
//		isRotating = false;
		
		int voffset = 20; // Fudge factor for changing position
		hsize = h; vsize = v;
		divX = hsize/20; divY=vsize/20; // for rate of rotation.
		cx = h/2; cy = v/2;
		int boxsize = vsize < hsize ? vsize : hsize;

//		mouseIsDown = false;
//		setLayout(new GridLayout(6,5));
		
		D3Face = new VCube(myFace,p,0,voffset,boxsize);
		
//		fR = new faceRotater(this);
		
//        addMouseMotionListener(this);
		int i,index;
//		Panel P = new Panel();
		RotateFaceButtons = new Button[3];
		for (i=0; i<3; i++) {
			if (i<myAxis) index = i%3;  // Adjust relative to this axis
			else index = i%3+1;
	    	RotateFaceButtons[i] = new Button ("x" + index);
	    	add(RotateFaceButtons[i]);
	    	RotateFaceButtons[i].addActionListener(this);

//			if (i==2)
//				P.add( new Label (" Face Rotations "));
			}

		// if the panel is clicked
		//		 if the cube is clicked, select (or unselect) that cubie
		//		else, cause a rotation to continue until the mouse is released.
        addMouseListener(new MouseAdapter() {
        	public void mousePressed(MouseEvent e) {
        		clickX = e.getX();
        		clickY = e.getY();
//        		System.out.println(e);
        		int idx = D3Face.getCubieIndex(clickX,clickY);
        		System.out.println(idx);
//        		System.out.println(fR);
        		if (idx != -1) {
        			parent.cubieClicked(idx);
					mouseIsDown = false;
//        			isRotating = false;
        			}
        		else mouseIsDown = true;
// 					{
//        			isRotating = true;
//        			fR.resume();
//        			}
 //        		mouseIsDown = true;
       		}
			public void mouseReleased(MouseEvent e) {
				mouseIsDown = false;
//				if (isRotating) {
//					fR.suspend();
//					isRotating = false;
//					}
//				mouseIsDown = false;
//				if (DEBUG) System.out.println("Released:  " + e);
//				fR.suspend();
        		}
        	}
        );

		myThread = new Thread(this);
//		myThread.setPriority(
		myThread.start();

		
//		Panel P1 = new Panel();
//		add(new Label("Drag to change visual orientation",Label.CENTER), "North");
//		P1.add(WhichFace);
		
//		add(P1,"North");
		
//		WhichFace = new Choice();
//		WhichFace.addItem("Dragging Rotates Face 1");
//		WhichFace.addItem("Dragging Rotates Face -1");
		
//		index = 0;
//		WhichFace.addItemListener(this);
		
//		add(WhichFace, "North");
		
//		add(P,"South");
//		pack();
	}  // end constructor
	
/*    Button initButton(String S)  {  //, Panel P) {	
    	Button B = new Button (S);
    	add(B);
    	B.addActionListener(this);
    	return B;
    	
    }
*/   


    public void run() {
        while (true) {
        	if (mouseIsDown) {
        		doRotate();
	        	try {
	        		myThread.sleep(smallSleep);
	        		}
	        	catch (InterruptedException e) {}
	        }
	        else 
	        	try {
	        		myThread.sleep(bigSleep);
	        		}
	        	catch (InterruptedException e) {}
        }
    }
    
    public void stop() {
    	myThread.stop();
    	}

    // Double buffering
    public void update(Graphics gc) {
    	if (OffScrImg == null) {
    		OffScrImg = createImage(getSize().width, getSize().height);
    		OffScrG = OffScrImg.getGraphics();
    		}
    	paint(OffScrG);
    	gc.drawImage(OffScrImg, 0, 0, this);
    	}

	public void doRotate() {
//		while (mouseIsDown){
		VisRotate( false, (cx-clickX)/divX);
		VisRotate( true,  (clickY-cy)/divY);
		repaint();
//	   	}	
//		if (DEBUG) System.out.println("Doing Rotation, face " + 
//				myFace + " " + clickX + " " +clickY);
	}
		
    public void RenderFace(Graphics g) {
    	D3Face.RenderCube(g);
    }
    
    // A drag event triggers a visual rotation
    // This should be changed to a mouse down/up checker.
/*    public void mouseDragged( MouseEvent e ) {
    	int x = e.getX(), y = e.getY();
    	
//    	int whichF, relCx;  // which face and where is the x center for this face.
    	
//    	if (x<cx) {whichF = 0; relCx = cx/2;}
//    	else {whichF = 1; relCx = 3*cx/2;}
    	
  		VisRotate( false, (cx-x)/divX);
		VisRotate( true,  (y-cy)/divY);
		repaint();
		
// 	 	VisRotate(VRotFace, (cx-x)/divX, (y-cy)/divY);
//    	if(DEBUG)System.out.println("Dragging:  " + e.getPoint());
//   		VisRotate(e.getX(),e.getY());
    		
    }
	
	public void itemStateChanged(ItemEvent e) {
//		int i; String which = (e.getItem()).toString();
//		if (which.endsWith(String.valueOf(1))) 
//			VRotFace = 0;
//		else VRotFace = 1;
	}

    public void mouseMoved( MouseEvent e ) { }

	public void mouseDown( MouseEvent e) {
		System.out.println("Mouse down " + e.getPoint());
		}
*/

	public void actionPerformed(ActionEvent e) {
    	int i, j, index;
    	int fixedlow, fixedhigh;  // the ordered fixed axes
    	int axis1=0, axis2=1;
    	// Check for layer rotation button
		for (j=0; j<3; j++) 
	        if ( e.getSource() == RotateFaceButtons[j] ) {
	        	index = j%3;
	        	if (j < myAxis) {
	        		fixedlow = j; fixedhigh = myAxis;
	       		}
	        	else {
	        		fixedlow = myAxis; fixedhigh = j+1;
	        	}
	        	
	        	// Now set axis1 and 2 appropriately.
				if (fixedhigh == 1) {axis1 = 2; axis2 = 3;}
				else if (fixedlow == 0) {
					axis1=1;
					if (fixedhigh == 2) axis2 = 3;
					else axis2 = 2;
					}
				else if (fixedlow == 1) axis2 = fixedhigh == 2 ? 3 : 2;
				
				if (parent.DEBUG) System.out.println("Fixed rotation axes:  " +
						 axis1 + " " + axis2 + " face: "  + myFace);
						 
				// face number is 2*axis + j/3
				parent.RotateFace(myFace, axis1, axis2, true);
				parent.RenderCube();
				return;
				}// end if jth rotate face button
		System.out.println("Action:  " + e);
	}  // end of action performed 


	// Visual rotation of a face.  0 is Face +1; 1 is Face -1.
	// caller must invoke repaint (so that multiple rotations can take place before)
	public void VisRotate(boolean horiz, int howmuch) {
//		int d;
		
		if (horiz) D3Face.orient.xrot(howmuch);
		else D3Face.orient.yrot(howmuch);

//		repaint();
	} // end visual rotate
	

/*		if (Face == 1) {
			F1.orient.
		// Check if more vertical or horiz drag.
		if (Math.abs(x-oldX) < Math.abs(y-oldY)) {
			d = dTheta * (y<oldY?-1:1);
			if (WhichFace.getSelectedItem().equals( "Face 1"))
				F1.orient.xrot(d);
			else F2.orient.xrot(d);
			}
		else {
			d = 5 * (x<oldX?-1:1);
			if (WhichFace.getSelectedItem().equals( "Face 1"))
				F1.orient.xrot(d);
			else F2.orient.xrot(d);
		}	
*/
	
	
	public void VReset() {
		D3Face.orient.unit();
		if (myFace > 3) D3Face.orient.xrot(180);
		}	
		
		
	public void paint(Graphics gc) {
        gc.setColor(Color.white);
        gc.fillRect(0,0,getSize().width, getSize().height);
		D3Face.RenderCube(gc);
		// Add visual orientation widget 
	}

} // face viewer

/*

// Class to rotate a face while the mouse button is down in 
// this face's panel.  
class faceRotater extends Thread {
	
//	protected boolean mouseIsDown;
	protected FaceViewer myFV;
//	protected int x,y;
	
	faceRotater (FaceViewer V) {
		myFV = V;
//		addMouseListener(this);
//		mouseIsDown = false;
		start();
		suspend();
		}
	
/*	public void going(int mx, int my) {
		mouseIsDown = true;
		x = mx; y = my;
		}
	
	public void notGoing() {
		mouseIsDown = false;
		}

	public void run() {
		while (true) {
//			if (mouseIsDown) {
				myFV.doRotate();
				if (myFV.DEBUG) System.out.println("Rotating ");
//				}
//			else 
//				suspend();
		}
	}
	
/*	public void mousePressed(MouseEvent e) {
		resume();
		x = e.getX();
		y = e.getY();
		if (myFV.DEBUG) System.out.println("Thread mousePressed");
	}
	
	public void mouseReleased(MouseEvent e) {
		mouseIsDown = false;
		suspend();	
	}
	
	public void mouse

} // end of face rotater
*/
